<template>
  <div class="upload">
    <label :for="id">{{ placeholder }}</label>
    <input
      v-bind="$attrs"
      :id="id"
      ref="file"
      type="file"
      name="file"
      @change="onUpload"
    />
  </div>
</template>

<script>
export default {
  name: 'InputFile',
  inheritAttrs: false,
  props: {
    id: {
      type: [Number, String],
      required: true,
    },
    placeholder: {
      type: String,
      required: false,
      default: 'Загрузить',
    },
  },
  methods: {
    /** @param {Event} e */
    onUpload(e) {
      const files = Array.from(e.target.files)
      if ('multiple' in this.$attrs) {
        this.$emit('upload', files)
      } else {
        this.$emit('upload', files[0])
      }
    },
    trigger() {
      this.$refs.file.click()
    },
  },
}
</script>
